#!/bin/bash
# Script: e17install - Install e17 cvs with libs
# Author: Steffen Wirth alias bert2002
# Date: 30.8.05
# Version: 0.7a
# www.pissflitsche.net/e17
version=0.7a
################################### check 
clear
type type >> /dev/null ; if [ $? == 1 ]; then echo "Checking type... failed... Please install type" && exit 1 ; else echo "Checking type... Okay" && sleep 0.2; fi
type cvs >> /dev/null ; if [ $? == 1 ]; then echo "Checking cvs... failed... Please install cvs" && exit 1 ; else echo "Checking cvs... Okay" && sleep 0.2; fi
type dialog >> /dev/null ; if [ $? == 1 ]; then echo "Checking dialog... failed... Please install dialog" && exit 1 ; else echo "Checking dialog... Okay" && sleep 0.2; fi
type make >> /dev/null ; if [ $? == 1 ]; then echo "Cheking make... failed... Please install make" && exit 1 ; else echo "Checking make... Okay" && sleep 0.2; fi

##########################################################################Source Area#######################################################################################
mkdir ~/.e17install/ 2> /dev/null
if [ -e ~/.e17install/.sourcecode ]; then
		echo "Sourcecode: Okay"
	else
			dialog --title "Sourcecode area" --backtitle "e17install $version" --inputbox "Where is the sourcecode from e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/.e17install 2> ~/.e17install/.sourcecode
			
		if [ $? == 0 ]; then
			echo "Sourcecode: Okay"
		else
			rm -rf ~/.e17install/.sourcecode 2> /dev/null
			echo "Cancel by user or Error: `$?`" && exit 1
		fi
	fi
e17source=`cat ~/.e17install/.sourcecode`
mkdir $e17source 2> /dev/null
touch $e17source/test 2> /dev/null
	if [ $? == 1 ]; then
		dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
		rm -rf ~/.e17install/.sourcecode 2> /dev/null
		exit 1
	else
		echo "Sourcecode read/write: Okay"
	fi
##########################################################################Install Area########################################################################################
if [ -e ~/.e17install/.e17path ]; then
		echo "e17 Install Path: Okay"
	else
################################### Test for user
		if [ `id -un` == root ]; then
			dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 /usr/local 2> ~/.e17install/.e17path
				if [ $? == 0 ]; then
					echo "e17 Install Path: Okay"
				else
					rm -rf ~/.e17install/.e17path 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
###################################
		else
			dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/e17 2> ~/.e17install/.e17path
		fi
				if [ $? == 0 ]; then
					echo "e17 Install Path: Okay"
				else
					rm -rf ~/.e17install/.e17path 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
	fi
e17path=`cat ~/.e17install/.e17path`
mkdir $e17path 2> /dev/null
touch $e17path/test 2> /dev/null
	if [ $? == 1 ]; then
		dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
		rm -rf ~/.e17install/.e17path 2> /dev/null
		exit 1
	else
		echo "e17 install path read/write: Okay"
	fi
############################################################################################################################################################################
export PATH=$PATH:$e17source:$e17path
###################################
dialog --title "Installer" --backtitle "e17install $version" --yesno "Do you want install/update enlightenment 17 now?" 5 55

if [ $? == 0 ]; then
	cd $e17source
	cvs -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment login || echo "Couldnt login to cvs server" || exit 1
	cvs -z3 -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment co e17 || echo "Error to get the source" || exit 1
	cvs -z3 -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment co misc || echo "Error to get the source" || exit 1
	mkdir ./e17/log/ 2> /dev/null
	rm -rf ./e17/log/*.log 2> /dev/null
	unset fehler
	
	echo "----------------"
	echo "Install libaries" && sleep 1
	for ilib in e17/libs/edb e17/libs/eet e17/libs/imlib2 e17/libs/imlib2_loaders e17/libs/evas e17/libs/ecore e17/libs/epeg e17/libs/epsilon e17/libs/embryo e17/libs/edje e17/libs/esmart e17/libs/emotion e17/libs/etox e17/libs/ewl e17/libs/engrave ; do
		cd $e17source && cd $ilib
		./autogen.sh --libdir=$e17path/lib/ --prefix=$e17path && make 2> $e17source/e17/log/`echo $ilib | cut -d / -f3`.log || fehler=1
		if [ fehler == 1 ] ; then 
		tail -f  $e17source/e17/log/`echo $ilib | cut -d / -f3`.log
		echo "Error to build $e17source/$ilib"
		unset fehler
		exit 1
		fi
		make install && ldconfig 2> /dev/null
	done 
	clear
	
	echo "------------"
	echo "Install Apps" && sleep 1
	for iapp in e17/apps/entice e17/apps/entrance e17/apps/elicit e17/apps/e misc/engage e17/apps/erss e17/apps/e_utils ; do
		cd $e17source && cd $iapp
		./autogen.sh --libdir=$e17path/lib/ --prefix=$e17path && make 2> $e17source/e17/log/`echo $iapp | cut -d / -f3`.log  || fehler=1
		if [ fehler == 1 ] ; then
		tail -f  $e17source/e17/log/`echo $iapp | cut -d / -f3`.log
		echo "Error to build $e17source/$iapp"
		unset fehler
		exit 1
		fi
		make install && ldconfig 2> /dev/null
	done
	cd $e17source/e17/log/ 2> /dev/null
	for ilog in `ls` ; do
		if [ -s $ilog ]; then
			echo ""
		else
			rm $ilog 2> /dev/null
		fi
	done

	
	if [ -x $e17path/bin/enlightenment ] ; then
		echo "startx $e17path/bin/enlightenment" > $e17path/bin/e17 && chmod a+x $e17path/bin/e17 2> /dev/null
	else
		dialog --title "Compile Error" --backtitle "e17install $version" --msgbox "Cannot locate enlightenment. Is everything compiled correctly?\nPlease look in $e17source/e17/log/ to find the error" 6 70
		exit 1
	fi
	clear
	dialog  --title "complete" --backtitle "e17install $version" --msgbox "We have installed follow libs: edb, eet, imlib2, imlib2_loaders, evas, ecore, epeg, epsilon, embryo, edje, esmart, emotion, etox, ewl and engrave\nand the followed apps: entice, entrance, elicit, e, engage, erss, e_utilsans e_modules" 8 80
	dialog --title "Ready to start" --backtitle "e17install $version" --msgbox "Enlightenment has more applications as we installed, look: $e17source/e17/apps/ and $e17source/misc/\nAn Error Log you can find in: $e17source/e17/log/\nYou can Start enlightenment with '$e17path/e17' in one tty. Please close X before you start e17." 8 75


	else
	dialog --ok-label "Bye" --title "What a bummer" --backtitle "e17install $version" --msgbox "You miss a great program.\nVisit www.pissflitsche.net/e17" 6 40
fi
